/*
 * Copyright 2022 Sony Corporation
 */
#ifndef _SONY_PANEL_H_
#define _SONY_PANEL_H_

#define ISBE_NONE	"None"	/* FE Only */
#define ISBE_4K		"4K"	/* With 4KBE */
#define ISBE_8K		"8K"	/* With 8KBE */

enum bedet_result {
	BEDET_INVALID = -1,
	BEDET_NONE = 0,
	BEDET_4K,
	BEDET_8K,

};

int paneldet_getPanelId(char *buf);
int paneldet_setPanelPower(bool enable);
int paneldet_setBacklightPowerFlush(void);
int paneldet_callback(void);
int paneldet_getBEType(void);
void paneldet_disablePanelTestPattern(void);

struct panel_det_i2c {
	uint32_t bus;
	uint32_t addr;
	uint32_t reg;
	uint32_t reg_size;
};

struct panel_det_priv {
	bool do_panelDet_check;
	bool do_panelId_read;
	bool do_panelId_check;
	struct panel_det_i2c panelI2Cbus;
	uint32_t panelDetIoNum[2];
	uint32_t panelPowerIoNum[2];
	uint32_t panelOnPreDelay;
	uint32_t panelOnPostDelay;
	uint32_t panelOffPreDelay;
	uint32_t panelOffPostDelay;
	uint32_t i2cDelay;
	uint32_t blPowerIoNum[2];
	uint32_t blOnPreDelay;
	uint32_t blOnPostDelay;
	uint32_t blOffPreDelay;
	uint32_t blOffPostDelay;
	uint32_t blStableDelay;
	bool blPowerSetting;

	bool isPanelLess;
	char panelId[17];
	char isBE[5];

	bool enable_testpattern_control;
	unsigned int testpattern_control_i2c_param[6];
};

#endif // _SONY_PANEL_H_
