/*
 * Copyright 2020,2021,2022 Sony Corporation
 */

#include <stdio.h>
#include <command.h>
#include <debug_impl.h>
#include <prodconfig_task.h>

int do_prodconfig_task(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	int ret = -1;

	ret = prodconfig_task();
	if (ret != 0) {
		UBOOT_ERROR("failed to set prodconfig to bootargs.\n");
		return CMD_RET_FAILURE;
	}
	return CMD_RET_SUCCESS;
}

int add_dev_serial_to_bootargs(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	int ret = -1;

	ret = add_serialno();
	if (ret != 0) {
		UBOOT_ERROR("failed to set serialno to bootargs.\n");
		return CMD_RET_FAILURE;
	}
	return CMD_RET_SUCCESS;
}

U_BOOT_CMD(
	prodconfig_task, CONFIG_SYS_MAXARGS, 1, do_prodconfig_task,
	"prodconfig_task - do set prodconfig to bootargs\n",
	NULL
);

U_BOOT_CMD(
	serialno, CONFIG_SYS_MAXARGS, 1, add_dev_serial_to_bootargs,
	"serialno - do set serialno to bootargs\n",
	NULL
);

