/* SPDX-License-Identifier: (GPL-2.0-only OR BSD-3-Clause) */
/*
 * Copyright (c) 2023 MediaTek Inc.
 */

#ifndef _MDRV_GFLIP_IO_H
#define _MDRV_GFLIP_IO_H

//=============================================================================
// Includs
//=============================================================================
#include "mdrv_gflip_st.h"

//=============================================================================
// Defines
//=============================================================================
//IO Ctrl defines:
#define MDRV_GFLIP_IOC_INIT_NR        (0)
#define MDRV_GFLIP_IOC_DEINIT_NR      (MDRV_GFLIP_IOC_INIT_NR+1)
#define MDRV_GFLIP_IOC_SETFLIPINFO_NR   (MDRV_GFLIP_IOC_DEINIT_NR+1)
#define MDRV_GFLIP_IOC_SETINPUTSIGSTATUS_NR    (MDRV_GFLIP_IOC_SETFLIPINFO_NR+1)
#define MDRV_GFLIP_IOC_GETDWININTINFO_NR    (MDRV_GFLIP_IOC_SETINPUTSIGSTATUS_NR+1)
#define MDRV_GFLIP_IOC_GETDWININTINFO2_NR   (MDRV_GFLIP_IOC_GETDWININTINFO_NR + 1)
#define MDRV_GFLIP_IOC_SETPIXELIDADDR_NR    (MDRV_GFLIP_IOC_GETDWININTINFO2_NR+1)
#define MDRV_GFLIP_IOC_SETGPIO3DPIN_NR  (MDRV_GFLIP_IOC_SETPIXELIDADDR_NR+1)
#define MDRV_GFLIP_IOC_ENABLEVECAPTURE_NR      (MDRV_GFLIP_IOC_SETGPIO3DPIN_NR+1)
#define MDRV_GFLIP_IOC_GETVECAPTURESTATE_NR    (MDRV_GFLIP_IOC_ENABLEVECAPTURE_NR+1)
#define MDRV_GFLIP_IOC_VECAPTUREWAITONFRAME_NR    (MDRV_GFLIP_IOC_GETVECAPTURESTATE_NR+1)
#define MDRV_GFLIP_IOC_CLEARFLIPQUEUE_NR     (MDRV_GFLIP_IOC_VECAPTUREWAITONFRAME_NR+1)
#define MDRV_GFLIP_IOC_SETGWININFO_NR     (MDRV_GFLIP_IOC_CLEARFLIPQUEUE_NR+1)
#define MDRV_GFLIP_IOC_DLCCHANGECURVE_NR   (MDRV_GFLIP_IOC_SETGWININFO_NR+1)
#define MDRV_GFLIP_IOC_DLCONOFFINFO_NR       (MDRV_GFLIP_IOC_DLCCHANGECURVE_NR+1)       //14
#define MDRV_GFLIP_IOC_SET3DFLIPINFO_NR       (MDRV_GFLIP_IOC_DLCONOFFINFO_NR+1)       //15
#define MDRV_GFLIP_IOC_BLECHANGEPOINT_NR      (MDRV_GFLIP_IOC_SET3DFLIPINFO_NR+1)       //16
#define MDRV_GFLIP_IOC_BLEONOFFINFO_NR        (MDRV_GFLIP_IOC_BLECHANGEPOINT_NR+1)       //17
#define MDRV_GFLIP_IOC_DLCGETHISTOGRAMINFO_NR  (MDRV_GFLIP_IOC_BLEONOFFINFO_NR+1)       //18
#define MDRV_GFLIP_IOC_SETMULTIFLIPINFO_NR  (MDRV_GFLIP_IOC_DLCGETHISTOGRAMINFO_NR+1)       //19
#define MDRV_GFLIP_IOC_GETVSYNC_NR  (MDRV_GFLIP_IOC_SETMULTIFLIPINFO_NR+1)       //20
#define MDRV_GFLIP_IOC_TLBSetTLBInfo_NR  (MDRV_GFLIP_IOC_GETVSYNC_NR+1)       //21
#define MDRV_GFLIP_IOC_TLBSET3DFLIPINFO_NR  (MDRV_GFLIP_IOC_TLBSetTLBInfo_NR+1)       //22
#define MDRV_GFLIP_IOC_SETTLBMULTIFLIPINFO_NR  (MDRV_GFLIP_IOC_TLBSET3DFLIPINFO_NR+1)       //23
#define MDRV_GFLIP_IOC_SETDLCINITINFO_NR  (MDRV_GFLIP_IOC_SETTLBMULTIFLIPINFO_NR+1)       //24
#define MDRV_GFLIP_IOC_STRIRQFLAG_NR  (MDRV_GFLIP_IOC_SETDLCINITINFO_NR+1)       //25
#define MDRV_GFLIP_IOC_SETIRQENABLE_NR  (MDRV_GFLIP_IOC_STRIRQFLAG_NR+1)       //26
#define MDRV_GFLIP_IOC_SETHDRFLAG_NR      (MDRV_GFLIP_IOC_SETIRQENABLE_NR+1)       //27
#define MDRV_GFLIP_IOC_SETHDRCENTRAL_CTRL_NR      (MDRV_GFLIP_IOC_SETHDRFLAG_NR+1)       //28
#define MDRV_GFLIP_IOC_CSCTUNING_NR  (MDRV_GFLIP_IOC_SETHDRCENTRAL_CTRL_NR+1)       //29
#define MDRV_GFLIP_IOC_GETVSYNC_EX_NR  (MDRV_GFLIP_IOC_CSCTUNING_NR+1)       //30

#define MDRV_GFLIP_IOC_DLCSETHDRINFO_NR  51       //51

#define MDRV_GFLIP_IOC_MAX_NR              (MDRV_GFLIP_IOC_DLCSETHDRINFO_NR+1)


// use 'm' as magic number
#define MDRV_GFLIP_IOC_MAGIC      ('2')
#define MDRV_GFLIP_IOC_INIT                     _IOR(MDRV_GFLIP_IOC_MAGIC,   MDRV_GFLIP_IOC_INIT_NR, MS_U32)
//#define MDRV_GFLIP_IOC_DEINIT     _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_DEINIT_NR, MS_U32)
#define MDRV_GFLIP_IOC_SETFLIPINFO       _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_SETFLIPINFO_NR, MS_GFLIP_INFO)
#define MDRV_GFLIP_IOC_SETINPUTSIGSTATUS    _IOR(MDRV_GFLIP_IOC_MAGIC,   MDRV_GFLIP_IOC_SETINPUTSIGSTATUS_NR, MS_BOOL)
#define MDRV_GFLIP_IOC_GETDWININTINFO       _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_GETDWININTINFO_NR, MS_GFLIP_DWININT_INFO)
#define MDRV_GFLIP_IOC_GETDWININTINFO2      _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_GETDWININTINFO2_NR, MS_GFLIP_DWININT_INFO2)
#define MDRV_GFLIP_IOC_SETPIXELIDADDR       _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_SETPIXELIDADDR_NR, MS_GFLIP_INFO)
#define MDRV_GFLIP_IOC_SETGPIO3DPIN         _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_SETGPIO3DPIN_NR, MS_GFLIP_INFO)
#define MDRV_GFLIP_IOC_ENABLEVECAPTURE      _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_ENABLEVECAPTURE_NR, MS_GFLIP_VECAPTURESTATE)
#define MDRV_GFLIP_IOC_GETVECAPTURESTATE    _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_GETVECAPTURESTATE_NR, MS_GFLIP_VECAPTURESTATE)
#define MDRV_GFLIP_IOC_VECAPTUREWAITONFRAME     _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_VECAPTUREWAITONFRAME_NR, MS_GFLIP_VECAPTURESTATE)
#define MDRV_GFLIP_IOC_CLEARFLIPQUEUE       _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_CLEARFLIPQUEUE_NR,MS_GFLIP_GOPGWINIDX)
#define MDRV_GFLIP_IOC_SETGWININFO          _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_SETGWININFO_NR,MS_GWIN_INFO)
#define MDRV_GFLIP_IOC_DLCCHANGECURVE       _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_DLCCHANGECURVE_NR,MS_DLC_INFO)
#define MDRV_GFLIP_IOC_DLCONOFFINFO          _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_DLCONOFFINFO_NR,MS_BOOL)
#define MDRV_GFLIP_IOC_SET3DFLIPINFO       _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_SET3DFLIPINFO_NR, MS_GFLIP_3DINFO)
#define MDRV_GFLIP_IOC_BLECHANGEPOINT       _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_BLECHANGEPOINT_NR,MS_BLE_INFO)
#define MDRV_GFLIP_IOC_BLEONOFFINFO          _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_BLEONOFFINFO_NR,MS_BOOL)
#define MDRV_GFLIP_IOC_DLCGETHISTOGRAMINFO     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_DLCGETHISTOGRAMINFO_NR,MS_U16)
#define MDRV_GFLIP_IOC_SETMULTIFLIPINFO     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_SETMULTIFLIPINFO_NR,MS_U16)
#define MDRV_GFLIP_IOC_GETVSYNC     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_GETVSYNC_NR,MS_U32)
#define MDRV_GFLIP_IOC_TLBSETFLIPINFO     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_TLBSetTLBInfo_NR,MS_TLB_GFLIP_INFO)
#define MDRV_GFLIP_IOC_TLBSET3DFLIPINFO       _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_TLBSET3DFLIPINFO_NR, MS_TLB_GFLIP_3DINFO)
#define MDRV_GFLIP_IOC_SETTLBMULTIFLIPINFO     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_SETTLBMULTIFLIPINFO_NR,MS_U16)
#define MDRV_GFLIP_IOC_SETDLCINITINFO     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_SETDLCINITINFO_NR,MS_DLC_INIT_INFO)
#define MDRV_GFLIP_IOC_STRIRQFLAG      _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_STRIRQFLAG_NR,MS_BOOL)
#define MDRV_GFLIP_IOC_SETIRQENABLE     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_SETIRQENABLE_NR,MS_BOOL)
#define MDRV_GFLIP_IOC_SETHDRFLAG      _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_SETHDRFLAG_NR, MS_SDR2HDR_INFO)
#define MDRV_GFLIP_IOC_SETHDRCENTRAL      _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_SETHDRCENTRAL_CTRL_NR, ST_HDR_CENTRAL_CTRL_INFO)
#define MDRV_GFLIP_IOC_CSCTUNING     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_CSCTUNING_NR,ST_GFLIP_GOP_CSC_PARAM)
#define MDRV_GFLIP_IOC_DLCSETHDRINFO     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_DLCSETHDRINFO_NR,MS_HDR_INFO)
#define MDRV_GFLIP_IOC_GETVSYNCEX     _IOWR(MDRV_GFLIP_IOC_MAGIC,MDRV_GFLIP_IOC_GETVSYNC_EX_NR,GFLIP_GETVSYNC_DATA)

#endif //_MDRV_GFLIP_IO_H
