

#include "include/aee_platform_debug.h"
#include "dev/systracker.h"

static unsigned int save_cpu_bus_data(u64 offset, int *len, CALLBACK dev_write)
{
    char *buf = NULL;
    int ret;
    unsigned int datasize = 0;

    /* Save systracker buffer */
    ret = systracker_get((void **)&buf, len, 8);
    if (ret && (buf != NULL)) {
        if (*len > 0)
            datasize += dev_write(buf, *len);
        systracker_put((void **)&buf);
    }
    return datasize;
}

static unsigned int save_dfd_data(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

static unsigned int save_spm_data(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

static unsigned int save_spm_sram_data(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

static unsigned int save_dram_data(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

#ifdef MTK_TINYSYS_SSPM_SUPPORT
static unsigned int save_sspm_coredump(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

static unsigned int save_sspm_data(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

static unsigned int save_sspm_xfile(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

static unsigned int save_sspm_last_log(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}
#endif

static unsigned int save_hvfs_data(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

static unsigned int save_pllk_last_log(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

static unsigned int save_log_dur_lkdump(u64 offset, int *len,
					CALLBACK dev_write)
{
	return 0;
}

static unsigned int save_mcdi_data(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}

#ifdef MTK_TINYSYS_SCP_SUPPORT
static unsigned int save_scp_coredump(u64 offset, int *len, CALLBACK dev_write)
{
	return 0;
}
#endif

/* platform initial function */
int platform_debug_init(void)
{
	printf("mt5896 platform debug init\n");
	modify_plat_dfd20_get(save_dfd_data);
	modify_plat_dram_get(save_dram_data);
	modify_plat_cpu_bus_get(save_cpu_bus_data);
	modify_plat_spm_data_get(save_spm_data);
	modify_plat_spm_sram_data_get(save_spm_sram_data);
	modify_plat_hvfs_get(save_hvfs_data);
#ifdef MTK_TINYSYS_SSPM_SUPPORT
	modify_plat_sspm_coredump_get(save_sspm_coredump);
	modify_plat_sspm_data_get(save_sspm_data);
	modify_plat_sspm_xfile_get(save_sspm_xfile);
	modify_plat_sspm_log_get(save_sspm_last_log);
#endif
	modify_plat_pllk_last_log_get(save_pllk_last_log);
	modify_plat_dur_lkdump_get(save_log_dur_lkdump);
	modify_plat_mcdi_get(save_mcdi_data);
#ifdef MTK_TINYSYS_SCP_SUPPORT
	modify_plat_scp_coredump_get(save_scp_coredump);
#endif

	return 1;
}
