/* SPDX-License-Identifier: (GPL-2.0 OR BSD-3-Clause) */
/*
 * Copyright (c) 2020 MediaTek Inc.
 */

#define CLK_TSP_XTAL_24M_INT_CK	2
#define CLK_TSP_SMI_INT_CK	3
#define CLK_TSP_MCU_NONPM_INT_CK	4
#define CLK_TSP_RIU_NONPM_INT_CK	5
#define CLK_TSP_IMI_INT_CK	6
#define CLK_TSP_USBPHY30_INT_CK	7
#define CLK_TSP_USBPHY240_MUX_INT_CK	8
#define CLK_TSP_USBPHY240_INT_CK	9
#define CLK_TSP_SMI_UHC_INT_CK	10
#define CLK_TSP_SMI_FCIE_INT_CK	11
#define CLK_TSP_SMI_AESDMA_INT_CK	12
#define CLK_TSP_SMI_TSP_INT_CK	13
#define CLK_TSP_FCIE_INT_CK	14
#define CLK_TSP_ECC_INT_CK	16
#define CLK_TSP_AESDMA_INT_CK	17
#define CLK_TSP_RC_INT_CK	18
#define CLK_TSP_NJPD_INT_CK	19
#define CLK_TSP_TSP_INT_CK	20
#define CLK_TSP_PARSER_INT_CK	21
#define CLK_TSP_STAMP_INT_CK	22
#define CLK_TSP_TSIF0_27M_INT_CK	23
#define CLK_TSP_MM0_27M_INT_CK	24
#define CLK_TSP_MM1_27M_INT_CK	25
#define CLK_TSP_PATH_FI_27M_INT_CK	26
#define CLK_TSP_PATH0_27M_INT_CK	27
#define CLK_TSP_PATH1_27M_INT_CK	28
#define CLK_TSP_PATH2_27M_INT_CK	29
#define CLK_TSP_PVR1_27M_INT_CK	30
#define CLK_TSP_PVR2_27M_INT_CK	31
#define CLK_TSP_PVR3_27M_INT_CK	32
#define CLK_TSP_PVR4_27M_INT_CK	33
#define CLK_TSP_FIQ0_27M_INT_CK	34
#define CLK_TSP_SYS_TIME0_27M_INT_CK	35
#define CLK_TSP_SYS_TIME1_27M_INT_CK	36
#define CLK_TSP_SYS_TIME2_27M_INT_CK	37
#define CLK_TSP_SYS_TIME3_27M_INT_CK	38
#define CLK_TSP_TLV0_27M_INT_CK	39
#define CLK_TSP_TLV1_27M_INT_CK	40
#define CLK_TSP_TLV2_27M_INT_CK	41
#define CLK_TSP_TS0_L_INT_CK	42
#define CLK_TSP_TS0_H_INT_CK	43
#define CLK_TSP_TS0_INT_CK	44
#define CLK_TSP_TS1_L_INT_CK	45
#define CLK_TSP_TS1_H_INT_CK	46
#define CLK_TSP_TS1_INT_CK	47
#define CLK_TSP_TS2_L_INT_CK	48
#define CLK_TSP_TS2_H_INT_CK	49
#define CLK_TSP_TS2_INT_CK	50
#define CLK_TSP_TSFI_L_INT_CK	51
#define CLK_TSP_TSFI_H_INT_CK	52
#define CLK_TSP_TSFI_INT_CK	53
#define CLK_TSP_TS_ALP0_L_INT_CK	54
#define CLK_TSP_TS_ALP0_H_INT_CK	55
#define CLK_TSP_TS_ALP0_INT_CK	56
#define CLK_TSP_TS_ALP1_L_INT_CK	57
#define CLK_TSP_TS_ALP1_H_INT_CK	58
#define CLK_TSP_TS_ALP1_INT_CK	59
#define CLK_TSP_TS_TLV0_L_INT_CK	60
#define CLK_TSP_TS_TLV0_H_INT_CK	61
#define CLK_TSP_TS_TLV0_INT_CK	62
#define CLK_TSP_TS_TLV1_L_INT_CK	63
#define CLK_TSP_TS_TLV1_H_INT_CK	64
#define CLK_TSP_TS_TLV1_INT_CK	65
#define CLK_TSP_TS_TLV2_L_INT_CK	66
#define CLK_TSP_TS_TLV2_H_INT_CK	67
#define CLK_TSP_TS_TLV2_INT_CK	68
#define CLK_TSP_TSO_TRACE_INT_CK	69
#define CLK_TSP_TSO_TRACE_IN_L_INT_CK	70
#define CLK_TSP_TSO_TRACE_IN_H_INT_CK	71
#define CLK_TSP_TSO_TRACE_IN_INT_CK	72
#define CLK_TSP_TSO_CH1_L_INT_CK	73
#define CLK_TSP_TSO_CH1_H_INT_CK	74
#define CLK_TSP_TSO_CH1_INT_CK	75
#define CLK_TSP_TSO_CH5_L_INT_CK	76
#define CLK_TSP_TSO_CH5_H_INT_CK	77
#define CLK_TSP_TSO_CH5_INT_CK	78
#define CLK_TSP_TSO_CH6_L_INT_CK	79
#define CLK_TSP_TSO_CH6_H_INT_CK	80
#define CLK_TSP_TSO_CH6_INT_CK	81
#define CLK_TSP_TSO_S2P_L_INT_CK	82
#define CLK_TSP_TSO_S2P_H_INT_CK	83
#define CLK_TSP_TSO_S2P_INT_CK	84
#define CLK_TSP_TSO_S2P1_L_INT_CK	85
#define CLK_TSP_TSO_S2P1_H_INT_CK	86
#define CLK_TSP_TSO_S2P1_INT_CK	87
#define CLK_TSP_TSO_TS_SRC_SEL_INT_CK	88
#define CLK_TSP_TSO_OUT_DIV_SEL_INT_CK	89
#define CLK_TSP_TSO_OUT_INT_CK	90
#define CLK_TSP_TSO_OUT2PAD_INT_CK	91
#define CLK_TSP_TSO_S2P2PAD_INT_CK	92
#define CLK_TSP_TSO_S2P12PAD_INT_CK	93
#define CLK_TSP_TSO_CH1_27M_INT_CK	94
#define CLK_TSP_TSO_CH5_27M_INT_CK	95
#define CLK_TSP_TSO_CH6_27M_INT_CK	96
#define CLK_TSP_TSO2_TRACE_INT_CK	97
#define CLK_TSP_TSO2_TRACE_IN_L_INT_CK	98
#define CLK_TSP_TSO2_TRACE_IN_H_INT_CK	99
#define CLK_TSP_TSO2_TRACE_IN_INT_CK	100
#define CLK_TSP_TSO2_CH1_L_INT_CK	101
#define CLK_TSP_TSO2_CH1_H_INT_CK	102
#define CLK_TSP_TSO2_CH1_INT_CK	103
#define CLK_TSP_TSO2_CH5_L_INT_CK	104
#define CLK_TSP_TSO2_CH5_H_INT_CK	105
#define CLK_TSP_TSO2_CH5_INT_CK	106
#define CLK_TSP_TSO2_CH6_L_INT_CK	107
#define CLK_TSP_TSO2_CH6_H_INT_CK	108
#define CLK_TSP_TSO2_CH6_INT_CK	109
#define CLK_TSP_TSO2_S2P_L_INT_CK	110
#define CLK_TSP_TSO2_S2P_H_INT_CK	111
#define CLK_TSP_TSO2_S2P_INT_CK	112
#define CLK_TSP_TSO2_S2P1_L_INT_CK	113
#define CLK_TSP_TSO2_S2P1_H_INT_CK	114
#define CLK_TSP_TSO2_S2P1_INT_CK	115
#define CLK_TSP_TSO2_TS_SRC_SEL_INT_CK	116
#define CLK_TSP_TSO2_OUT_DIV_SEL_INT_CK	117
#define CLK_TSP_TSO2_OUT_INT_CK	118
#define CLK_TSP_TSO2_OUT2PAD_INT_CK	119
#define CLK_TSP_TSO2_S2P2PAD_INT_CK	120
#define CLK_TSP_TSO2_S2P12PAD_INT_CK	121
#define CLK_TSP_TSO2_CH1_27M_INT_CK	122
#define CLK_TSP_TSO2_CH5_27M_INT_CK	123
#define CLK_TSP_TSO2_CH6_27M_INT_CK	124
#define CLK_TSP_TS_TX_C1_L_INT_CK	125
#define CLK_TSP_TS_TX_C1_H_INT_CK	126
#define CLK_TSP_TS_TX_C1_INT_CK	127
#define CLK_TSP_TS_TX_C1_L_EXT_PRE_INT_CK	128
#define CLK_TSP_TS_TX_C1_H_EXT_PRE_INT_CK	129
#define CLK_TSP_TS_TX_C1_EXT_PRE_INT_CK	130
#define CLK_TSP_TS_TX_C1_EXT_INT_CK	131
#define CLK_TSP_TS_TX_C2_L_INT_CK	132
#define CLK_TSP_TS_TX_C2_H_INT_CK	133
#define CLK_TSP_TS_TX_C2_INT_CK	134
#define CLK_TSP_TS_TX_C2_L_EXT_PRE_INT_CK	135
#define CLK_TSP_TS_TX_C2_H_EXT_PRE_INT_CK	136
#define CLK_TSP_TS_TX_C2_EXT_PRE_INT_CK	137
#define CLK_TSP_TS_TX_C2_EXT_INT_CK	138
#define CLK_TSP_CILINK_IF_INT_CK	139
#define CLK_TSP_CILINK_2B_TX_INT_CK	140
#define CLK_TSP_CILINK_2B_TX_EXT_INT_CK	141
#define CLK_TSP_CILINK_2B_RX_INT_CK	142
#define CLK_TSP_TS0_IN_DFT_INT_CK	143
#define CLK_TSP_TS1_IN_DFT_INT_CK	144
#define CLK_TSP_TS2_IN_DFT_INT_CK	145
#define CLK_TSP_TS3_IN_DFT_INT_CK	146
#define CLK_TSP_TS4_IN_DFT_INT_CK	147
#define CLK_TSP_TS5_IN_DFT_INT_CK	148
#define CLK_TSP_TS_SAMPLE_DFT_INT_CK	149
#define CLK_TSP_TSO_OUT_DIV_MN_SRC_INT_CK	150
#define CLK_TSP_TSO2_OUT_DIV_MN_SRC_INT_CK	151
#define CLK_TSP_TS_SAMPLE_INT_CK	152
#define CLK_TSP_SYN_STC0_INT_CK	153
#define CLK_TSP_SYN_STC1_INT_CK	154
#define CLK_TSP_SYN_STC2_INT_CK	155
#define CLK_TSP_SYN_STC3_INT_CK	156
#define CLK_TSP_UFS_INT_CK	157
#define CLK_TSP_UFS_AES_INT_CK	160
#define CLK_TSP_UFS_RX_SYMBOL_INT_CK	161
#define CLK_TSP_UFS_TX_SYMBOL_INT_CK	162
#define CLK_TSP_UFS_UNIPRO_CG_SYN_INT_CK	163
#define CLK_TSP_UFS_MP_SAP_CFG_INT_CK	164
#define CLK_TSP_SSUSB_XHCI_INT_CK	165
#define CLK_TSP_SSUSB_SYS_INT_CK	166
#define CLK_TSP_SSUSB_FRMCNT_INT_CK	167
#define CLK_TSP_SSUSB_PCLK_INT_CK	168
#define CLK_TSP_SSUSB_PCLK_1P_INT_CK	169
#define CLK_TSP_SSUSB_USB20_PHY_CLK_INT_CK	172
#define CLK_TSP_SSUSB_USB20_PHY_CLK_1P_INT_CK	173
#define CLK_TSP_SSUSB_USB20_PHY_CLK_2P_INT_CK	174
#define CLK_TSP_PEXTP_TL_INT_CK	175
#define CLK_TSP_PEXTP_PL_PCLK_INT_CK	177
#define CLK_TSP_PEXTP_AHB_APB_INT_CK	178
#define CLK_TSP_NR	179
